#!/bin/bash

if [[ $# != 2 ]]
then
    echo "sqrt-5b.bash <target> <digits>"
    exit 1
fi

export BC_LINE_LENGTH=200

p=5

target=$1

digits=$2

################ check for final digit ################

val=$target

while [[ $val -lt 0 ]]
do
  val=$(( val + p ))
done

val=$(( val % p ))

if [[ $val != 4 ]]
then
    echo "error: final base-5 digit of target must be 4"
    exit 1
fi

################ begin iteration ################

sqrt=2

digit_lookup[0]=0
digit_lookup[1]=1
digit_lookup[2]=2
digit_lookup[3]=3
digit_lookup[4]=4

position=1

while :
do
  [[ $position -eq $digits ]] && break

  sqrt_base_p=$(echo -e "obase=$p \n $sqrt" | bc -q)

  sqr_base_p=$(echo -e "obase=$p \n $sqrt * $sqrt" | bc -q)

  printf "%${digits}s %$((digits * 2))s\n" $sqrt_base_p $sqr_base_p

  offset=0

  while :
  do
    d=$(echo "(($sqrt*$sqrt - $target + $offset * ($p^($position+1))) % ($p^($position+1)))/($p^$position) " | bc -q)

    [[ $d -ge 0 ]] && break

    offset=$((offset+1))
  done

  new_digit=${digit_lookup[d]}

  sqrt=$(echo "$sqrt + ($new_digit * ($p ^ $position))" | bc -q)

  position=$((position + 1))
done

echo "sqrt($target) ~ $sqrt"
