#!/bin/bash

export BC_LINE_LENGTH=200

p=2

target=$1

digits=$2

sign=$3

if [[ $(( (target + 8*(1-target/8))%8 )) != 1 ]]
then
    echo "error: target must be of the form 8n+1"
    exit 1
fi

sqrt=$(((target-1)/2))

[[ $sqrt -lt 0 ]] && sqrt=$((-sqrt))

[[ $sign == + ]] && sqrt=$((sqrt+1))
[[ $sign == - ]] && sqrt=$((sqrt-1))

while :
do
  sqrt_base_2=$(echo -e "obase=2 \n $sqrt" | bc -q)

  printf "%${digits}s %s\n" $sqrt_base_2 $sqrt

  result=$(echo -e "obase=2 \n $sqrt*$sqrt - $target" | bc -q)

  zeros=$(echo "$result" | awk '{s=length($0); sub("0+$",""); t=length($0); print s-t;}')

  zeros=$((zeros-1))

  [[ $zeros -ge $digits ]] && exit

  incr=$(echo "2 ^ $zeros" | bc -q)

  sqrt=$((sqrt+incr))
done
