#!/bin/bash

export BC_LINE_LENGTH=200

p=2

n=$1

p_to_the_n=$(echo "2 ^ $n" | bc -q)

# Just like 1 has two square roots (ie. 1 and -1)
# and 9 has two square roots (ie. 3 and -3),
# in the 2-adic world, 17 has two square roots.
# One of them is closer to 9 and one of them is closer to 7.
# The square root closer to 9 is sort of like the positive
# square root and the square root closer to 7 is sort of
# like the negative square root.  Uncomment either one
# of these two lines of code to find the positive or the
# negative square root of 17 to a lot of 2-adic digits.
# This should not be surprising - we can always multiply
# a square root by -1 to get another square root.  And
# in fact the 2-adic expansion of the two different square
# roots of a number are very similar since one is the
# negative of the other.  The two numbers agree in the
# least significant digit position and then differ in
# every other position.
#
# 746962075387746583 =>
# 101001011101101111100000110011001100001011001101100100010111
#
# 405959429219100393 =>
#  10110100010010000011111001100110011110100110010011011101001
#
# 101001011101101111100000110011001100001011001101100100010111
#  10110100010010000011111001100110011110100110010011011101001

#sqrt=9
sqrt=7

i=1

while [[ $i -lt 30 ]]
do
  echo "$sqrt"

  result=$(echo -e "obase=2 \n $sqrt*$sqrt - 17" | bc -q)

  zeros=$(echo "$result" | awk '{s=length($0); sub("0+$",""); t=length($0); print s-t;}')

  zeros=$((zeros-1))

  incr=$(echo "2 ^ $zeros" | bc -q)

  sqrt=$((sqrt+incr))

  i=$((i+1))
done
